#ifndef __STOS__H_
#define __STOS__H_
#include <stdlib.h>
#include "klasy.h"
class st_elem
{
  public:
  Node *wartosc;
  st_elem *prev;
};

class stos
{
   public:
   stos();
   void push(Node *);
   Node *pop();
   private:
   st_elem *bottom;
   st_elem *top;
}st;

stos::stos()
{
  top=bottom=NULL;
}

void stos::push (Node *anode)
{
  st_elem *tmp=new st_elem;
  tmp->prev=NULL;
  tmp->wartosc=anode;
  if (!bottom)
	bottom = tmp;
  else
	tmp->prev = top;
  top=tmp;
}

Node *stos::pop()
{
  st_elem *tmp = top->prev;
  Node *result = top->wartosc;
  delete top;
  top = tmp;
  if (!top) bottom = NULL;
  return result;
}
#endif