#ifndef __KLASY_H
#define __KLASY_H
#include "list.h";
class Node
{
  public:
  Node();
  ~Node();
  char Value;  // 1- identyfikator, '&' - &, '|'- |
  char Negated;
  int NumLeftPar;
  int NumRightPar;
  Node *Left;
  Node *Right;
  void ProcessNode(FILE *);
  void AddPar();
  void RemovePar();
};

Node::Node()
{
  Value=0;
  Negated=0;
  NumLeftPar=NumRightPar=0;
  Left=Right=NULL;
}

Node::~Node()
{
  if (Left) delete Left;
  if (Right) delete Right;
}

void Node::ProcessNode(FILE *awhereto)
{
  if (Left)
  {
    if (Negated)
      fprintf(awhereto,"!");
    Left->ProcessNode(out);
    fprintf(awhereto,"%c", Value);
    Right->ProcessNode(out);
  }
  else
  {
    int i;
    for (i=0; i<NumLeftPar;i++)
      fprintf(awhereto, "(");
    if (Negated)
      fprintf(awhereto,"!");
    getfromlist();
    for (i=0; i<NumRightPar;i++)
      fprintf(awhereto, ")");
  }
}

void Node::AddPar()
{
  if (Left)
  {
    Node *tmp = Left;
    while (tmp->Left)
      tmp = tmp->Left;
    tmp->NumLeftPar ++;
    tmp = Right;
    while (tmp->Right)
      tmp = tmp->Right;
    tmp->NumRightPar ++;
  }
}

void Node::RemovePar()
{
  if (Left)
  {
    Node *tmp = Left;
    while (tmp->Left)
      tmp = tmp->Left;
    tmp->NumLeftPar --;
    tmp = Right;
    while (tmp->Right)
      tmp = tmp->Right;
    tmp->NumRightPar --;
  }
}

#endif
