/*
  lista jednokierunkowa napisana w czystym c
  dla potrzeb konwertera z rwna boolowskich na posta odwrotnej notacji polskiej
  Pawe Muszyski 2000
*/

#ifndef __LIST_H
#define __LIST_H
#include <string.h>
#include <malloc.h>
int addtolist(char* elem);   // dodawanie acucha znakw do listy (z alokacj koniecznej pamici i przekopiowaiem acucha) - kopiowanie lancucha
int getfromlist(); // pobranie acucha z listy do bufora, zwolnienie pamieci, bufor musi zmiescic caly lancuch - kopiowanie lancucha
                   //zwracaja 0 gdy sukces i -1 przy bledzie
void initializelist();  //inicjalizacja listy

struct list_elem {
  	struct list_elem *next;
	int ifspace;
  	char *text;
};

int islistempty();

struct Tlist{
  	struct list_elem *totake;
  	struct list_elem *whereput;
}list;


int addtolist(char *elem)
{
  int size=strlen(elem);
  struct list_elem *current=(struct list_elem*)calloc(1,sizeof(struct list_elem));
  current->text=(char *)calloc(size+1,sizeof(char));
  if (!(current->text)) return -1;
  strcpy(current->text,elem);
  if (list.whereput) {list.whereput->next=current;}
  list.whereput=current;
  if (!list.totake) list.totake=current;
  current->next=NULL;
  return 0;
}

int getfromlist()
{
  struct list_elem *tmp;
  if (!list.totake) return -1;
  tmp=list.totake->next;
  fprintf(outf,"%s",list.totake->text);
  free(list.totake->text);
  free(list.totake);
  if(!tmp) list.whereput=NULL;
  list.totake=tmp;
  return 0;
}


void initializelist()
{
 list.totake=NULL;
 list.whereput=NULL;
}
#endif
